<?php

namespace Testpackageprovider\Test\Policies;

use App\User;
use Illuminate\Auth\Access\HandlesAuthorization;
use Testpackageprovider\Test\Models\Testarticles;

class TestarticlesPolicy
{
    use HandlesAuthorization;

    /**
     * Determine if the given user can view the testarticles.
     *
     * @param User $user
     * @param Testarticles $testarticles
     *
     * @return bool
     */
    public function view(User $user, Testarticles $testarticles)
    {
        if ($user->canDo('test.testarticles.view') && $user->is('admin')) {
            return true;
        }

        return $user->id === $testarticles->user_id;
    }

    /**
     * Determine if the given user can create a testarticles.
     *
     * @param User $user
     * @param Testarticles $testarticles
     *
     * @return bool
     */
    public function create(User $user)
    {
        return  $user->canDo('test.testarticles.create');
    }

    /**
     * Determine if the given user can update the given testarticles.
     *
     * @param User $user
     * @param Testarticles $testarticles
     *
     * @return bool
     */
    public function update(User $user, Testarticles $testarticles)
    {
        if ($user->canDo('test.testarticles.update') && $user->is('admin')) {
            return true;
        }

        return $user->id === $testarticles->user_id;
    }

    /**
     * Determine if the given user can delete the given testarticles.
     *
     * @param User $user
     * @param Testarticles $testarticles
     *
     * @return bool
     */
    public function delete(User $user, Testarticles $testarticles)
    {
        if ($user->canDo('test.testarticles.delete') && $user->is('admin')) {
            return true;
        }

        return $user->id === $testarticles->user_id;
    }

    /**
     * Determine if the user can perform a given action ve.
     *
     * @param [type] $user    [description]
     * @param [type] $ability [description]
     *
     * @return [type] [description]
     */
    public function before($user, $ability)
    {
        if ($user->isSuperUser()) {
            return true;
        }
    }
}
