<?php

namespace Testpackageprovider\Test\Providers;

use Illuminate\Foundation\Support\Providers\RouteServiceProvider as ServiceProvider;
use Illuminate\Routing\Router;
use Testpackageprovider\Test\Models\Test;
use Request;

class RouteServiceProvider extends ServiceProvider
{
    /**
     * This namespace is applied to the controller routes in your routes file.
     *
     * In addition, it is set as the URL generator's root namespace.
     *
     * @var string
     */
    protected $namespace = 'Testpackageprovider\Test\Http\Controllers';

    /**
     * Define your route model bindings, pattern filters, etc.
     *
     * @param   \Illuminate\Routing\Router  $router
     * @return void
     */
    public function boot(Router $router)
    {
        parent::boot($router);

        if (Request::is('*/test/testarticles/*')) {
            $router->bind('testarticles', function ($id) {
                $testarticles = $this->app->make('\Testpackageprovider\Test\Interfaces\TestarticlesRepositoryInterface');
                return $testarticles->findorNew($id);
            });
        }if (Request::is('*/test/user/*')) {
            $router->bind('user', function ($id) {
                $user = $this->app->make('\Testpackageprovider\Test\Interfaces\UserRepositoryInterface');
                return $user->findorNew($id);
            });
        }

    }

    /**
     * Define the routes for the application.
     *
     * @param \Illuminate\Routing\Router $router
     *
     * @return void
     */
    public function map(Router $router)
    {
        $router->group(['namespace' => $this->namespace], function ($router) {
            require __DIR__ . '/../Http/routes.php';
        });
    }
}
